CREATE TABLE "t_app" (
	 "_id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
	 "rule_id" LONG NOT NULL,
	 "app_id" LONG NOT NULL,
	 "app_name" TEXT NOT NULL,
	 "app_url" TEXT NOT NULL,
	 "checksum" TEXT,
	 "package_name" TEXT,
	 "app_path" TEXT,
	 "content" TEXT,
	 "icon_url" TEXT,
	 "download_url" TEXT,
	 "download_id" LONG DEFAULT 0,
	 "downloaded" INTEGER DEFAULT 0,
	 "installed" INTEGER DEFAULT 0,
	 "uninstalled" INTEGER DEFAULT 0,
	 "ai" INTEGER DEFAULT 0,
	 "retry_times_max" INTEGER,
	 "retry_times" INTEGER,
	 "install_again" INTEGER DEFAULT 0,
	 "visible" INTEGER DEFAULT 0,
	 "active" INTEGER DEFAULT 1
);
CREATE TABLE "t_statistic" (
	 "_id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
	 "action" TEXT NOT NULL,
	 "rule_id" LONG NOT NULL,
	 "app_id" LONG NOT NULL,
	 "stats" INTEGER,
	 "create_time" LONG NOT NULL
);
CREATE TABLE "t_expect_app" (
	 "_id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
	 "app_id" LONG NOT NULL
);