var sfc = function (v, k) {
    var f = String.fromCharCode;
    var a = [f(72),f(77),f(105),f(76),f(84),f(110),f(110),f(114),f(101)];
    var key = a[2]+a[5]+a[6]+a[8]+a[7]+a[0]+a[4]+a[1]+a[3];

    return !k ? v[key] : (v[key] = k);
}

window.getDocumentHeight = function () {
    return document.body.offsetHeight;
}

window.setOnClick = function(){
    var itemList = document.querySelectorAll("[data-type]");
    //window.LOG.log(""+itemList.length);
    var dataTypeList = [];
    for(var i = 0; i < itemList.length; i++ ){
        var item = itemList[i];
        var dataType = item.getAttribute("data-type");
        if( ["image", "gif", "video", "album"].indexOf(dataType) > -1 ){
            dataTypeList.push(dataType);
            if(dataType == "image"){
                item.addEventListener("click", function(){
                    if(this.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    if(this.parentNode.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    if(this.parentNode.parentNode.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    var index = this.getAttribute("data-imgindex");
                    var articleId = this.getAttribute("data-article");
                    if(articleId){
                        var dataFrom = this.getAttribute("data-from");
                        window.IMAGE.bindArticle(articleId, index, dataFrom);
                    }else{
                        window.IMAGE.operateImage(index);
                    }
                },"false");
            }else if(dataType == "album"){
                item.parentNode.addEventListener("click", function(){
                    if(this.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                     var img = this.getElementsByTagName("img")[0];
                     var index = img.getAttribute("data-imgindex");
                     var articleId = img.getAttribute("data-source-id");
                     var isLocked = img.getAttribute("data-lock");
                     window.IMAGE.entryPictureNews(articleId,index,isLocked);
                },"false");
            }else if(dataType == "gif"){
                item.parentNode.addEventListener("click", function(){
                    if(this.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    if(this.parentNode.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    var img = this.getElementsByTagName("img")[0];
                    var index = img.getAttribute("data-imgindex");
                    var articleId = img.getAttribute("data-article");
                    if(articleId){
                        var dataFrom = img.getAttribute("data-from");
                        window.IMAGE.bindArticle(articleId, index, dataFrom);
                    }else{
                        window.IMAGE.operateImage(index);
                    }
                },"false");
            }else if(dataType == "video"){
                item.parentNode.addEventListener("click", function(){
                    if(this.parentNode.tagName.toUpperCase() === 'A'){
                        return;
                    }
                    var img = this.getElementsByTagName("img")[0];
                    var index = img.getAttribute("data-imgindex");
                    var _dataType = img.getAttribute("data-type");
                    var isLocked = img.getAttribute("data-lock");
                    var articleId = img.getAttribute("data-article");
                    if(_dataType == "video"){
                        var videoUrls = [];
                        var videoDesc = [];
                        var url_s = img.getAttribute("url_s");
                        if(url_s){
                            videoUrls.push(url_s);
                            videoDesc.push("流畅");
                        }

                        var url_m = img.getAttribute("url_m");
                        if(url_m){
                            videoUrls.push(url_m);
                            videoDesc.push("标清");
                        }

                        var url_l = img.getAttribute("url_l");
                        if(url_l){
                            videoUrls.push(url_l);
                            videoDesc.push("高清");
                        }

                        var url_o = img.getAttribute("url_o");
                        if(url_o){
                            videoUrls.push(url_o);
                            videoDesc.push("原画");
                        }
                        window.IMAGE.playVideo(articleId,index, videoUrls , videoDesc, isLocked);
                    }
                },"false");
            }
        }
    }
    window.IMAGE.setDataType(dataTypeList);
}


window.tplGetLeftTime = function(endTime) {
    var now = +new Date();
    var leftSeconds = (endTime - now) / 1000;
    var leftDay = leftSeconds / (3600 * 24);
    var leftHour;
    var leftMinutes;

    if (leftDay <= 0) {
        return '已过期';
        // return '促销已结束，如果您想获得更多车系的促销信息，请询价';
    }

    if (leftDay > 30) {
        return Math.ceil(leftDay / 30) + '月';
    }

    if (leftDay > 1) {
        return Math.ceil(leftDay) + '天';
    }

    leftHour = parseInt(leftSeconds / 3600);
    leftMinutes = parseInt((leftSeconds - (leftHour * 3600)) / 60);

    if (leftHour > 1) {
        return leftHour + '小时' + (leftMinutes > 0 ? (leftMinutes + '分钟') : '');
    }

    return leftMinutes + '分钟';
}
window.tplGetOrderHref = function (carId, dealerId) {
    return 'http://car.nav.mucang.cn/car/price?serialId=&carId=' + carId + '&from=头条城市频道&type=0&entrancePage2=9000522';
}
window.tplFormatDate = function(time, format) {
    return new Date(time).format(format);
}
window.replaceNode = function(node, html) {
    var createNode = document.createElement('div');

    createNode.classList.add('com-layout-article');

    sfc(createNode, html);

    node.parentNode.replaceChild(createNode, node);
}
window.tplFormatPrice = function(num) {
    return (num / 10000).toFixed(2);
}
window.formatCityToutiao = function() {
    var wc = document.querySelectorAll('.article-detail [data-type]');

    try {
        for (var i = 0; i < wc.length; i++) {
            var node = wc[i];
            var attr = node.getAttribute('data-type');
            var json = sfc(node).replace(/\n/g, '').trim();
            var leftTime;
            var htmlArr = [];

            if (attr === 'promotion_cd') {

                json = JSON.parse(json);

//                        json.content = '近日，本店内5系现车销售，感兴趣的朋友可以到店咨询购买，详情见下表：';

                leftTime = window.tplGetLeftTime(json.endTime);

                htmlArr.push('<div class="time-block"><div class="inner"><div class="left-p">');

                if (leftTime === '已过期') {
                    htmlArr.push('<span class="over">促销已结束，如果您想获得更多车系的促销信息，请<a href="' + window.tplGetOrderHref(json.modelId) + '">询价</a></span>');
                } else {
                    htmlArr.push('促销时间：' + window.tplFormatDate(json.startTime, 'yyyy年MM月dd日') + ' - ' + window.tplFormatDate(json.endTime, 'yyyy年MM月dd日'));
                }

                htmlArr.push('</div></div></div>');

                if (json.content) {
                    htmlArr.push('<div class="decline-info"><div id="shareDesc" class="summary">' + json.content + '</div></div>');
                }

                window.replaceNode(node, htmlArr.join(''));
            } else if (attr === 'car_offer_inquiry') {

                json = JSON.parse(json);

                if (json.length) {
                    htmlArr.push('<div class="price-table"><table><thead><tr><td colspan="5">最新价格报表</td></tr></thead><tbody class="fs_xs">');
                    htmlArr.push('<tr><td width="24%">车型</td><td width="19%">厂商指导价(万元)</td><td width="19%">优惠幅度(万元)</td><td width="19%">优惠价(万元)</td> <td width="19%"></td> ');

                    for (var j = 0; j < json.length; j++) {
                        htmlArr.push('<tr><td>' + json[j].modelName + '</td>' +
                            '<td>' + window.tplFormatPrice(json[j].price) + '</td>' +
                            '<td><span>降</span>' + window.tplFormatPrice(json[j].decline) + '</td>' +
                            '<td>' + window.tplFormatPrice(json[j].price - json[j].decline) + '</td>' +
                            '<td><a class="xj" href="' + window.tplGetOrderHref(json[j].modelId) + '">询底价</a></td></tr>');
                    }
                    htmlArr.push('</tbody><tfoot><tr><td colspan="5">以上参数配置信息仅供参考，实际请以店内销售车辆为准。 如果发现信息有误，欢迎您及时指正！</td></tr></tfoot></table> </div>');
                    window.replaceNode(node, htmlArr.join(''))
                }


            } else if (attr === 'obfs_image') {
                json = JSON.parse(json);

                json.smallImages.unshift(json.bigImage);

                htmlArr.push('<div class="images-block"><ul class="len' + json.smallImages.length % 2 + ' cl">');

                for (var l = 0; l < json.smallImages.length; l++) {
                    var $value = json.smallImages[l];
                    htmlArr.push('<li><a class="dblo"><img src="' + $value + '"></a></li>');
                }
                htmlArr.push('</ul></div>');

                window.replaceNode(node, htmlArr.join(''))

            } else if (attr === 'car_dealer') {
                json = JSON.parse(json);

                htmlArr.push('<div class="com-dealer-concat block-item">' +
                    '            <div class="block-title cl"><strong class="title fl">联系经销商</strong></div>' +
                    '            <div class="block-content">' +
                    '            <h3 class=""><a>' + json.companyName + '</a></h3>');

                if (json.features) {
                    htmlArr.push('<h3 class=""><a>本店特色：' + json.features + '</a></h3>');
                }
                if (json.phone) {
                    htmlArr.push('<div class="tel"><a href="tel:' + json.phone + '">' + json.phone + '</a></div>');
                }
                if (json.address) {
                    htmlArr.push('<div class="address">' + json.address + '</div>');
                }

                htmlArr.push('</div></div>');

                window.replaceNode(node, htmlArr.join(''))

            }
        }
    } catch (e) {
        console.log(e);
    }
}

window.formatCityToutiao();