DROP TABLE IF EXISTS `t_car_browse_history`;
DROP TABLE IF EXISTS `t_car_contact_history`;
DROP TABLE IF EXISTS `t_car_favorite`;
DROP TABLE IF EXISTS `t_car_modes_compare`;
DROP TABLE IF EXISTS `t_sell_car_info`;
DROP TABLE IF EXISTS `t_car_image`;

CREATE TABLE `t_car_browse_history`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `board_time` TEXT, `brand` INTEGER, `brand_name` TEXT, `carid` TEXT, `city` INTEGER, `city_name` TEXT, `create_time` INTEGER, `displacement` REAL, `gearbox` INTEGER, `imagesmall` TEXT, `is_deleted` INTEGER, `mileage` INTEGER, `model` INTEGER, `model_name` TEXT, `price` REAL, `seller_type` INTEGER, `series` INTEGER, `series_name` TEXT, `status` INTEGER, `style` TEXT, `time` INTEGER, `title` TEXT, `author_string` TEXT, `author_id` INTEGER, `user` TEXT, `is_auth` INTEGER, `labels` TEXT);
CREATE TABLE `t_car_contact_history`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `board_time` TEXT, `brand` INTEGER, `brand_name` TEXT, `carid` TEXT, `city` INTEGER, `city_name` TEXT, `contact_type` INTEGER, `create_time` INTEGER, `displacement` REAL, `gearbox` INTEGER, `imagesmall` TEXT, `is_deleted` INTEGER, `mileage` INTEGER, `model` INTEGER, `model_name` TEXT, `price` REAL, `seller_type` INTEGER, `series` INTEGER, `series_name` TEXT, `status` INTEGER, `style` TEXT, `time` INTEGER, `title` TEXT, `author_string` TEXT,`author_id` INTEGER, `user` TEXT, `phone` TEXT, `is_auth` INTEGER, `labels` TEXT);
CREATE TABLE `t_car_favorite`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `board_time` TEXT, `brand` INTEGER, `brand_name` TEXT, `carid` TEXT, `city` INTEGER, `city_name` TEXT, `create_time` INTEGER, `displacement` REAL, `gearbox` INTEGER, `imagesmall` TEXT, `is_deleted` INTEGER, `mileage` INTEGER, `model` INTEGER, `model_name` TEXT, `price` REAL, `seller_type` INTEGER, `series` INTEGER, `series_name` TEXT, `status` INTEGER, `style` TEXT, `time` INTEGER, `title` TEXT, `author_string` TEXT, `author_id` INTEGER, `user` TEXT, `is_uploaded` INTEGER, `is_auth` INTEGER, `labels` TEXT);
CREATE TABLE `t_car_modes_compare`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `board_time` TEXT, `brand` INTEGER, `brand_name` TEXT, `carid` TEXT, `city` INTEGER, `city_name` TEXT, `create_time` INTEGER, `displacement` REAL, `gearbox` INTEGER, `imagesmall` TEXT, `is_deleted` INTEGER, `mileage` INTEGER, `model` INTEGER, `model_name` TEXT, `price` REAL, `seller_type` INTEGER, `series` INTEGER, `series_name` TEXT, `status` INTEGER, `style` TEXT, `time` INTEGER, `title` TEXT, `author_string` TEXT, `author_id` INTEGER, `user` TEXT);
CREATE TABLE `t_sell_car_info`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `board_time` TEXT, `brand` INTEGER, `brand_name` TEXT, `color` TEXT, `car_type` TEXT, `carid` TEXT, `city` INTEGER, `city_name` TEXT, `create_time` INTEGER, `description` TEXT, `displacement` REAL, `gearbox` INTEGER, `imagesmall` TEXT, `include_transfer_fee` INTEGER, `insurance_expires` TEXT, `maintenance_record` TEXT, `mileage` INTEGER, `model` INTEGER, `model_name` TEXT, `price` REAL, `reason` TEXT, `seller_contacter` TEXT, `seller_phone` TEXT, `seller_sex` INTEGER, `seller_type` INTEGER, `series` INTEGER, `series_name` TEXT, `status` INTEGER, `style` TEXT, `title` TEXT,`author_string` TEXT,`transfer_times` INTEGER,`author_id` INTEGER, `user` TEXT);
CREATE TABLE `t_car_image`(`_id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `car_info_entity_id` INTEGER, `label` TEXT, `local_path` TEXT);